const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ClaimsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const claims = await db.claims.create(
      {
        id: data.id || undefined,

        category: data.category || null,
        description: data.description || null,
        status: data.status || null,
        attachments: data.attachments || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await claims.setTenant(data.tenant || null, {
      transaction,
    });

    await claims.setClient(data.client || null, {
      transaction,
    });

    await claims.setReservation(data.reservation || null, {
      transaction,
    });

    await claims.setAgences(data.agences || null, {
      transaction,
    });

    return claims;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const claimsData = data.map((item, index) => ({
      id: item.id || undefined,

      category: item.category || null,
      description: item.description || null,
      status: item.status || null,
      attachments: item.attachments || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const claims = await db.claims.bulkCreate(claimsData, { transaction });

    // For each item created, replace relation files

    return claims;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const claims = await db.claims.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.category !== undefined) updatePayload.category = data.category;

    if (data.description !== undefined)
      updatePayload.description = data.description;

    if (data.status !== undefined) updatePayload.status = data.status;

    if (data.attachments !== undefined)
      updatePayload.attachments = data.attachments;

    updatePayload.updatedById = currentUser.id;

    await claims.update(updatePayload, { transaction });

    if (data.tenant !== undefined) {
      await claims.setTenant(
        data.tenant,

        { transaction },
      );
    }

    if (data.client !== undefined) {
      await claims.setClient(
        data.client,

        { transaction },
      );
    }

    if (data.reservation !== undefined) {
      await claims.setReservation(
        data.reservation,

        { transaction },
      );
    }

    if (data.agences !== undefined) {
      await claims.setAgences(
        data.agences,

        { transaction },
      );
    }

    return claims;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const claims = await db.claims.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of claims) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of claims) {
        await record.destroy({ transaction });
      }
    });

    return claims;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const claims = await db.claims.findByPk(id, options);

    await claims.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await claims.destroy({
      transaction,
    });

    return claims;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const claims = await db.claims.findOne({ where }, { transaction });

    if (!claims) {
      return claims;
    }

    const output = claims.get({ plain: true });

    output.tenant = await claims.getTenant({
      transaction,
    });

    output.client = await claims.getClient({
      transaction,
    });

    output.reservation = await claims.getReservation({
      transaction,
    });

    output.agences = await claims.getAgences({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userAgences = (user && user.agences?.id) || null;

    if (userAgences) {
      if (options?.currentUser?.agencesId) {
        where.agencesId = options.currentUser.agencesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.tenants,
        as: 'tenant',

        where: filter.tenant
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.tenant
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  name: {
                    [Op.or]: filter.tenant
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.clients,
        as: 'client',

        where: filter.client
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.client
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  first_name: {
                    [Op.or]: filter.client
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.reservations,
        as: 'reservation',

        where: filter.reservation
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.reservation
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  ref: {
                    [Op.or]: filter.reservation
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.agences,
        as: 'agences',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.category) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('claims', 'category', filter.category),
        };
      }

      if (filter.description) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('claims', 'description', filter.description),
        };
      }

      if (filter.attachments) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('claims', 'attachments', filter.attachments),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.agences) {
        const listItems = filter.agences.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          agencesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.agencesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.claims.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('claims', 'category', query),
        ],
      };
    }

    const records = await db.claims.findAll({
      attributes: ['id', 'category'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['category', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.category,
    }));
  }
};
